/*

 Cipher+.H - Cipher Data Functions

extern int Cipher(char *xSource, char *xTarget, char *Incode_Key)

*/

extern int Cipher(char *xSource, char *xTarget, char *Incode_Key)
{
	int EndOfFile = 0;
	char CharBuffer = '\0';

	DWORD SourceFileSize = 0;
	long double Current_Size = 0;

	SourceFileSize = FileSize(xSource);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 11.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	FILE *Source;
	FILE *Target;

	if((Source = fopen(xSource,"rb")) == NULL)
	{
		Error("Could Not Open Source For Read. Error: 12.");
		if(Source)fclose(Source);
		return 0;
	}
	if((Target = fopen(xTarget,"wb")) == NULL)
	{
		Error("Could Not Open Temp File For Write. Error: 13.");
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		return 0;
	}

	if(strlen(Incode_Key) < 10)
		fprintf(Target,"0");

	fprintf(Target,"%d",strlen(Incode_Key));
	fprintf(Target,"~%s~",Incode_Key);

	EndOfFile = 1; /* not EOF */
	while(EndOfFile != EOF)
	{
		if(CancelFlag)
		{
			if(Source)fclose(Source);
			if(Target)fclose(Target);
			CleanUp(0,1);
			return 0;
		}
		CharBuffer = '\0';
		EndOfFile = fscanf(Source, "%c", &CharBuffer);
		if(EndOfFile != EOF) fprintf(Target, "%c", CharBuffer + 128);
		Current_Size++;
		StatusValue = ((Current_Size / SourceFileSize) * 100);
	}

	if(Source)fclose(Source);
	if(Target)fclose(Target);

	return 1;
}

