/*

 PackFiles.H - Pack Files & Folders Into One File

extern int PackFiles(char *SourceDirectory, char *DestinationFile)
extern int Get_FileNames(char *xInputDir)
extern int Get_SubFileNames(char *xInputDir, char *xSubDir)

*/

///////////////////////////////////////////////////////////////////////

extern int PackFiles(char *SourceDirectory, char *DestinationFile)
{

	FILE *LocalTarget;
	FILE *LocalSource;

	DWORD SourceFileSize = 0;

	float xFileCount = 0;
	float xLocalLoop = 0;

	int LocalLoop = 0;
	int CurrentBuffer = 0;

	char Buffer[512];
	char LocalTemp[1024];
	char StatusTemp[1024];

	if(Get_FileNames(SourceDirectory)) // Get Names Of Folders And Dirs
	{
		return 0;
	}

	if(FileCount == 0)
	{
		Status = "Folder Contains No Files";
		return 0;
	}

	/* Open Target File For Write */
	if((LocalTarget = fopen(DestinationFile,"wb")) == NULL)
	{
		if(LocalTarget)fclose(LocalTarget);
		Error("Could Not Open File For Write. Error 22.");
		return 0;
	}

	//Write Number Of Files (Begin)
	if(FileCount < 100000)
		fprintf(LocalTarget,"0");
	if(FileCount < 10000)
		fprintf(LocalTarget,"0");
	if(FileCount < 1000)
		fprintf(LocalTarget,"0");
	if(FileCount < 100)
		fprintf(LocalTarget,"0");
	if(FileCount < 10)
		fprintf(LocalTarget,"0");
	fprintf(LocalTarget,"%d",FileCount);
	//Write Number Of Files (End)

	fprintf(LocalTarget,"|");

	//Write Number Of Folders (Begin)
	if(FolderCount < 100000)
		fprintf(LocalTarget,"0");
	if(FolderCount < 10000)
		fprintf(LocalTarget,"0");
	if(FolderCount < 1000)
		fprintf(LocalTarget,"0");
	if(FolderCount < 100)
		fprintf(LocalTarget,"0");
	if(FolderCount < 10)
		fprintf(LocalTarget,"0");
	fprintf(LocalTarget,"%d",FolderCount);
	//Write Number Of Folders (End)

	fprintf(LocalTarget,"|");

	//Write File Name Leingths & Names (Begin)
	LocalLoop = 0;
	while(LocalLoop < FileCount)
	{
		if(strlen(FileNames[LocalLoop]) < 100)
			fprintf(LocalTarget,"0");
		if(strlen(FileNames[LocalLoop]) < 10)
			fprintf(LocalTarget,"0");
		fprintf(LocalTarget,"%d",strlen(FileNames[LocalLoop]));
		fprintf(LocalTarget,"%s",FileNames[LocalLoop]);
		LocalLoop++;
	}
	//Write File Name Leingths & Names (End)

	fprintf(LocalTarget,"|");
	sprintf(StatusTemp,"Packing %d Files && %d Folders",FileCount,FolderCount);
	Status = StatusTemp;

	xFileCount = FileCount;

	//Write Folder Name Leingths & Names (Begin)
	LocalLoop = 0;
	while(LocalLoop < FolderCount)
	{
		if(strlen(FolderNames[LocalLoop]) < 100)
			fprintf(LocalTarget,"0");
		if(strlen(FolderNames[LocalLoop]) < 10)
			fprintf(LocalTarget,"0");
		fprintf(LocalTarget,"%d",strlen(FolderNames[LocalLoop]));
		fprintf(LocalTarget,"%s",FolderNames[LocalLoop]);
		LocalLoop++;
	}
	//Write Folder Name Leingths & Names (End)

	fprintf(LocalTarget,"|");

	//Write File Size & Data (Begin)
	LocalLoop = 0;
	while(LocalLoop < FileCount)
	{
		sprintf(LocalTemp,"%s\\%s",SourceDirectory,FileNames[LocalLoop]);

		/* Write File Size */
		SourceFileSize = FileSize(LocalTemp);
		if(SourceFileSize < 100000000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 10000000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 1000000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 100000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 10000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 1000)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 100)
			fprintf(LocalTarget,"0");
		if(SourceFileSize < 10)
			fprintf(LocalTarget,"0");
		fprintf(LocalTarget,"%d",SourceFileSize);

		/* Open Target File */
		if((LocalSource = fopen(LocalTemp,"rb")) == NULL)
		{
			if(LocalSource)fclose(LocalSource);
			if(LocalTarget)fclose(LocalTarget);
			Error("Could Not Open File For Read. Error 23.");
			return 0;
		}

		/* Write File Data */
		do
		{
			if(CancelFlag)
			{
				if(LocalSource)fclose(LocalSource);
				if(LocalTarget)fclose(LocalTarget);
				unlink(DestinationFile);
				CleanUp(0,1);
				return 0;
			}

			Buffer[0] = '\0';
			CurrentBuffer = fread(Buffer,sizeof(char),BufferSize,LocalSource);
			fwrite(Buffer,sizeof(char),CurrentBuffer,LocalTarget);
		}
		while(CurrentBuffer == BufferSize);

		if(LocalSource)fclose(LocalSource);
		LocalLoop++;
		xLocalLoop = LocalLoop;
		StatusValue = ((xLocalLoop / xFileCount) * 100);
	}
	//Write File Size & Data (End)

	FreeMemory();

	if(LocalSource)fclose(LocalSource);
	if(LocalTarget)fclose(LocalTarget);

	return 1 ;
}

///////////////////////////////////////////////////////////////////////

extern int Get_FileNames(char *xInputDir)
{
	WIN32_FIND_DATA FindData;
	HANDLE FileHandle;
	int Found = 0;
	int LocalLoop = 0;
	char DirTemp[257];

	sprintf(DirTemp,"%s\\%s",xInputDir,"*.*");
	FileHandle = FindFirstFile(DirTemp,&FindData);
	Found = (int) FileHandle;

	while (Found != 0)
	{
		if( strcmp(FindData.cFileName,".") && strcmp(FindData.cFileName,"..") ) // If (Not) NULL Or Root
		{
			/* If Found Data Is A Directory */
			if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				FolderNames[FolderCount] = (char *) malloc(257);
				sprintf(FolderNames[FolderCount],"%s",FindData.cFileName);
				FolderCount++;
			}
			else{	/* If Found Data Is A File */
				FileNames[FileCount] = (char *) malloc(257);
				sprintf(FileNames[FileCount],"%s",FindData.cFileName);
				FileCount++;
			}
		}
		if(FileCount > MaxFiles || FolderCount > MaxFiles)
		{
			char StatusTemp[257];
			sprintf(StatusTemp,"Max Of %d Files And Folders",MaxFiles);
			Status = StatusTemp;
			return 1;
		}
		Found = FindNextFile(FileHandle, &FindData);
	}
	FindClose(FileHandle);

	if(FolderCount != 0) // If AtLeast One Folder Was Found
	{
		LocalLoop = 0;
		while(LocalLoop < FolderCount)
		{
			if(Get_SubFileNames(xInputDir,FolderNames[LocalLoop]))
			{
				return 1;
			}
			LocalLoop++;
		}
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Get_SubFileNames(char *xInputDir, char *xSubDir)
{
	WIN32_FIND_DATA FindData;
	HANDLE FileHandle;
	int Found = 0;
	BOOL FoundDir = FALSE;
	int NeededMemory = 0;

	char DirTemp[257];

	sprintf(DirTemp,"%s\\%s\\%s",xInputDir,xSubDir,"*.*");
	FileHandle = FindFirstFile(DirTemp,&FindData);
	Found = (int) FileHandle;

	while (Found != 0)
	{
		/* If Found Data Is A Directory */
		if( strcmp(FindData.cFileName,".") && strcmp(FindData.cFileName,"..") ) // If (Not) NULL Or Root
		{
			if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				NeededMemory = strlen(xSubDir) + strlen(FindData.cFileName) + 10;
				FolderNames[FolderCount] = (char *) malloc(NeededMemory);
				sprintf(FolderNames[FolderCount],"%s\\%s",xSubDir,FindData.cFileName);
				FoundDir = TRUE;
				FolderCount++;
			}
			else{ /* If Found Data Is A File */
				NeededMemory = strlen(xSubDir) + strlen(FindData.cFileName) + 10;
				FileNames[FileCount] = (char *) malloc(NeededMemory);
				sprintf(FileNames[FileCount],"%s\\%s",xSubDir,FindData.cFileName);
				FileCount++;
			}
		}
		if(FileCount > MaxFiles || FolderCount > MaxFiles)
		{
			char StatusTemp[257];
			sprintf(StatusTemp,"Max Of %d Files And Folders",MaxFiles);
			Status = StatusTemp;
			return 1;
		}
		Found = FindNextFile(FileHandle, &FindData);
	}
	FindClose(FileHandle);
	return 0;
}

///////////////////////////////////////////////////////////////////////

